﻿use net, io, graph as g, math, ui, time, system, files, proc

ip=null;
port=null;
pathd="e:";


//fa scegliere il drive in cui salvare i dati
function chdrive();
  dr=files.roots();
  try
    drn=ui.list(dr,false,[],"Select drive");
    cd(dr[drn[0]]);
  catch e by
    chdrive();
  end;
end;

//imposta e salva i parametri del prog
function set(onlynet = false)
  params = ui.form(["IP":"192.168.1.102", "Port":50000], "Settings");
  if(params = null) then
    return;
  else
    if files.exists(system.docdir+"csetting.cfg") then
      files.delete(system.docdir+"csetting.cfg");
    end;
    cfgfile = io.create(system.docdir + "csetting.cfg");
    io.writeln(cfgfile, params[0]);
    io.writeln(cfgfile, str(params[1]));
    .ip=params[0];
    .port=params[1];

    //se si vuole impostare anche drive di salvataggio
    if not onlynet then
      path="";
      while( (path="") or (path="D:\\") or (path="Z:\\")) do
        if path#"" then
          ui.error("Cannot save data on drive Z or D (Reserved)");
        end;
        chdrive();
        path=cd();
      end;
      io.writeln(cfgfile,cd());
      .pathd=cd();
      io.close(cfgfile);
    else
      io.writeln(cfgfile, .pathd);
      io.close(cfgfile);
    end;
  end;

end;

//recupera le impostazioni
function get()
  if(files.exists(system.docdir + "csetting.cfg")) then
    file = io.open(system.docdir + "csetting.cfg");
    .ip = io.readln(file);
    io.seek(file,1,true);
    .port = num(io.readln(file));
    io.seek(file,1,true);
    .pathd=io.readln(file);
    io.close(file);
  else
    set();
  end;
end;


/**INIZIO APP**/

ui.keys (ui.strokes | ui.opt2);
ui.mode(2);
g.pen(g.red);

ui.label(0, "MotionDetector-Client");
ui.label(1, "Options");
ui.label(2, "Capture");
prog=0;

//ciclo principale app
while true do

    options = ["Connect", "Settings", "Connection Info", "App Info", "Quit"];
    ui.menu("Options", options, false);

    get();//recupera impostazioni

    //prima di connect
    cmd=null;
    while not (cmd="Connect") do
      cmd=ui.cmd();
      if cmd = ui.opt2key then
        ui.msg("Nothing to capture", "MotionDetector-Client");
      end;
      if cmd = "Quit" then
        if ui.confirm("Do you really want to close the application?", "Confirm Exit") then
          proc.close();
        end;
      end;
      if cmd = "Connection Info" then
        ui.msg("NOT CONNECTED","Connection Status");
      end;
      if cmd = "App Info" then
        ui.msg("Created by Giovanni Rossi\n(12/2012) v1.0\nDownloaded from <mshelldevelop.altervista.org>","Infos");
      end;
      if cmd = "Settings" then
        set();
      end;
    end;

    //nuovo menu
    options = ["Disconnect", "Settings", "Connection Info", "App Info", "Quit"];
    ui.menu("Options", options, false);
    //

    while ip=null do
      ip=ui.query("IP","Client","192.168.1.102");
    end;

    while port=null do
      port=ui.query("Port","Client",50000);
    end;
    ui.busy("Connecting...");

    net.start(true);
    c=null;

    /*per segnalare se qualcosa è andato male nella connessione*/
    retry = false;

    try
      c = net.conn(ip,port);
      //print "connected";
    catch e by
      ui.busy();
      ui.error("Unable to connect to IP "+ ip + ", PORT "+port+"\n\nMight be wrong.");
      net.stop();
      set(true);
      ui.msg("Now try to reconnect with new parameters", "Reconnect");
      retry = true;
    end;

    tcon=time.get();

    exit = false;
    //loop connessione avvenuta
    while true do

      //qualcosa non è andato bene in fase di connessione
      if retry then
        break;
      end;
      ui.busy();
      //attesa pressione bottone
      cmd = ui.cmd(100);
      if cmd = ui.opt2key then
        g.save(.pathd+"screen"+str(prog)+".jpg",0,0,336,252);
        prog++;
        ui.msg("Captured", "MotionDetector-Client");
      end;
      if cmd = "Disconnect" then
        if ui.confirm("Do you really want to close the connection?", "Confirm Disconnection") then
          break;
        end;
      end;
      if cmd = "Quit" then
        if ui.confirm("Do you really want to close the connection and the application?", "Confirm Exit") then
          exit = true;
          break;
        end;
      end;
      if cmd = "Connection Info" then
        ui.msg("IP: "+ip+"\nPort: "+port+"\nUp time: " + str(math.floor(time.get()-tcon))+ " sec","Connection Status");
      end;
      if cmd = "App Info" then
        ui.msg("Created by Giovanni Rossi\n(12/2012) v1.0\nDownloaded from <mshelldevelop.altervista.org>","Infos");
      end;
      if cmd = "Settings" then
        set();
      end;
      
      //inizia scambio dati
      while (io.readln(c))#"_start_" do
       sleep(100);
      end;
      crlf=io.read(c,1);//crlf

      size=num(io.readln(c));
      crlf=io.read(c,1);//crlf


      chunck=65536;
      i=0;

      nb= math.floor(size/chunck);
      nr= size%chunck;

      g.text(20,20,"REFRESHING...");
      g.show();
  
      file = io.create(.pathd+"img.jpg");

      while(i<nb) do
        i++;
        io.write(file, io.read(c, chunck));
      end;

      if nr#0 then
        io.write(file, io.read(c, nr));
      end;
      io.close(file);

      i=g.icon(.pathd+"img.jpg");
      g.size(i,336,252);
      g.put(0,0,i);
      g.text(10,245, time.str(time.get(),"DD-MM-YYYY hh:mm:ss"));
      g.show();
      io.writeln(c,"_continue_");
      //print "server-continue";
    end; //fine loop connessione
    if not retry then
      io.writeln(c, "_end_");
      if io.read(c, 11) = "_can_close_" then
        net.shut(c,false);
      end;
    end;

    if exit then
      break;
    end;
end;//fine loop principale

ui.mode(0);

/**FINE APP**/
