﻿use cam2 as c, graph as g, array as a, math, audio, system, time, io, net, ui, proc, mail, flash, files

sect=0;

function chdrive();
  dr=files.roots();
  try
    drn=ui.list(dr,false,[],"Select drive");
    cd(dr[drn[0]]);
  catch e by
    chdrive();
  end;
end;

function avg(m, grid)

  step=10;
  sum=0;
  tot = 0;

  for i=0 to grid-1 by step do
    for j=0 to grid-1 by step do
      sum = sum + m[i][j];
      tot++;
    end;
  end;
  return math.floor(sum/tot);

end;

function cfr(now, oldv, size)
  sense=820000;
  for i = 0 to size-1 do
    if(oldv[i]#0 and ((math.abs(now[i]-oldv[i]))>sense)) then
      .sect=i;
      return true;
    end;
  end;
  return false;
end;


function detect(x, y, grid, size, now, oldv)
  index=0;
  for i=0 to x-1 by grid do
    for j=0 to y-1 by grid do
      mat=g.get(i,j,grid,grid);
      now[index] = avg(mat, grid);
      index++;
    end;
 end;

//confronta array
return cfr(now, oldv, size);
end;

port=50000;
interval = 2;
show = false;
beep = false;
mailno = 0;
prog = 0;
mailto="";
pathd="e:";

function sett()
  set = ui.form(["Show Cam":true, "Connection", "Port:":50000,"Frequency (sec):": 2, "On Capture", "Beep":true, "email":""],"Settings");
  if set = null then
    return;
  end;
  if files.exists(system.docdir+"cmotion.cfg") then
    files.delete(system.docdir+"cmotion.cfg");
  end;
  file = io.create(system.docdir+"cmotion.cfg");
  if set[0] then
    io.writeln(file, "true");
    .show=true;
  else
    io.writeln(file, "false");
    .show=false;
    g.clear();
    g.show();
  end;

  io.writeln(file, str(set[1]));
  .port=set[1];
  io.writeln(file, str(set[2]));
  .inteval=set[2];
  if set[3] then
    io.writeln(file, "true");
    .beep=true;
  else
    io.writeln(file, "false");
    .beep=false;
  end;
  io.writeln(file, set[4]);
  .mailto=set[4];
  ui.msg("Enable Port Forwarding for port " + str(.port) + " with TCP on your router, or you will not able to contact this app remotely with client-side app!", "Warning");

  path="";
  while( (path="") or (path="D:\\") or (path="Z:\\")) do
    if path#"" then
      ui.error("Cannot save data on drive Z or D (Reserved)");
    end;
    chdrive();
    path=cd();
  end;
  io.writeln(file,cd());
  .pathd=cd();
  io.close(file);
end;

function get()
  if files.exists(system.docdir + "cmotion.cfg") then
    f = io.open(system.docdir + "cmotion.cfg");
    if io.readln(f)="true" then
      .show=true;
    else
      .show=false;
      g.clear();
      g.show();
    end;
    io.seek(f,1,true);
    .port=num(io.readln(f));
    io.seek(f,1,true);
    .interval=num(io.readln(f));
    io.seek(f,1,true);
    if io.readln(f)="true" then
      .beep=true;
    else
      .beep=false;
    end;
    io.seek(f,1,true);
    .mailto=io.readln(f);
    io.seek(f,1,true);
    .pathd=io.readln(f);
    io.close(f);
  else
    sett();
  end;
  return;

end;

function take()

  g.save( .pathd+"frame"+str( .prog)+".jpg",0,0,160,120);

  try
    mail.index(0);
    mail.send(.mailto, "MotionDetector", "WARNING - MOTION CAPTURED!!",[system.docdir + "frame"+str(.prog)+".jpg"]);
  catch e by 
    ui.error("Unable to send mail:\n"+e);
  end;

  .prog++;
end;

/***INIZIO PROGRAMMA***/

pread=proc.pipe("cserver", true);
pwrite=proc.pipe("cmain",true);

options=["Settings" ,"App Info", "Quit"];
ui.keys(ui.strokes | ui.opt2);
ui.label(0,"MotionDetector");
ui.label(1,"Options");
ui.label(2,"Background");
ui.menu("Options",options,false);
get();

proc.run("cam-server", str(port));

c.on(640, 480);
c.icon(true);
s = c.view();//160*120
img=null;

g.pen(g.red);

grid=40;
size = (s[0]/grid)*(s[1]/grid);
oldv = array.create(size, 0); //media vecchia
now  = array.create(size, 0); //media attuale

start=time.get();

status=false;

while true do
  
  cmd=ui.cmd(100);
  if(cmd = ui.opt2key) then
    proc.hide("MotionDetector-NET");
  end;
  if(cmd = "App Info") then
    ui.msg("Created by Giovanni Rossi\n(12/2012) v1.0\nDownloaded by <mshelldevelop.altervista.org>","Infos");
  end;
  if(cmd = "Settings") then
    sett();
  end;
  if(cmd = "Quit") then
    if ui.confirm("Do you really want to close the application?", "Confirm Exit") then
      break;
    end;
  end;
 

  if not proc.runs("cam-server") then
    net.stop();
    try
      proc.close("cam-server");
      proc.run("cam-server", str(port));
    catch e by
      print "server-side app not available";
      status=false;
    end;
    status=false;
  end;
  img=c.icon(img);
  g.put(0,0,img);

//invio
  //print "check";
  if io.avail(pread)>=14 then
    //print "pipe-available";
    msg=io.read(pread,14);
    if msg="_server_start_" then 
      status=true;
      //print "server-started";
    end;
    if msg="_server_stop__" then 
      status=false;
    end;
  end;

  if status and (time.get()-start)>interval then
    if io.read(pread,6)="_capt_" then
      //print "can capture";
      g.save("c:frame.jpg",0,0,s[0],s[1]);
      io.write(pwrite, "_start_"); 
      //print "can send";
      start=time.get();
    end;
  end;
//fine invio

  
  if (detect(s[0], s[1], grid, size, now,oldv)) then
    //print "changed sector: "+sect;
    //send-mail e memorizza file(nome generato con time)
    //take();
    if beep then
      audio.beep(2000, 3);
      while audio.busy() do
        sleep(3);
      end;
    end;
  end;
  oldv=a.copy(now,0); //copia nuovi val nei vecchi
  //print oldv;
  if(show) then
    g.show();
  end;

  if io.avail(pread)=5 then
    if io.read(pread,5)="_end_" then
      status=false;
    end;
  end;
end;

if proc.runs("cam-server") then
  proc.close("cam-server");
end;

io.close(pread);
io.close(pwrite);
