﻿use net, io

connection=null; //stream connessione
timeout = 3000; //msec

//funzione per iniziare l'attesa di connessioni
function startServer(port=50000)
  net.stop();
  //net.iap(true); //fa scegliere quale access point usare
  net.start(true);
  pStream = net.listen(port, '0.0.0.0', 1);
  ..connection = net.accept(pStream);

  oldces = io.ces(..connection, io.raw);
  //io.writem(..connection, "OK Connessione Stabilita\n");

  return ..connection; //connessione stabilita
end;

//funzione per chiudere una connessione (se esiste)
function closeConn()
  if(..connection # null) then
    net.shut(..connection, false);
    ..connection = null;
    return true; //chiusa con successo
  end;
  return false; //se connessione non era aperta prima
end;

//funzione per impostare il timeout
function setTimeout(ms)
  if(ms > 2147483 and ms < 0) then
    return false;  //impossibile impostare timeout fuori da questi limiti
  end;

  ..timeout = net.timeout(ms);
  return ..timeout;
end;

//funzione per inviare dati al client
function sendData(data)

  if(..connection=null) then
    return -1; //connessione non aperta
  end;

  io.write(..connection, data);
  return len(data);

end;

//funzione per ricevere dati al client
function recData()

  if(..connection=null) then
    return -1; //connessione non aperta
  end;
  data= io.readln(..connection);
  io.flush(..connection);
  return data;
end